<template>
  <div class="app-container">
    <el-form :model="queryParams" ref="queryForm" :inline="true" v-show="showSearch" label-width="68px">
      <!--      <el-form-item label="业务编号" prop="fBillno">-->
      <!--        <el-input-->
      <!--          v-model="queryParams.fBillno"-->
      <!--          placeholder="请输入业务编号"-->
      <!--          clearable-->
      <!--          size="small"-->
      <!--          @keyup.enter.native="handleQuery"-->
      <!--        />-->
      <!--      </el-form-item>-->
      <el-form-item label="客户名称" prop="fCorpid">
        <el-select
          v-model="queryParams.fCorpid"
          filterable
          remote
          clearable
          style="width: 200px"
          @keyup.enter.native="handleQuery"
          :remote-method="corpsRemoteMethod"
          placeholder="请输入客户名称"
        >
          <el-option
            v-for="(dict, index) in fMblnoOptions"
            :key="index.fId"
            :label="dict.fName"
            :value="dict.fId"
          ></el-option>
        </el-select>
      </el-form-item>
      <!--      <el-form-item label="货物品名" prop="fGoodsid">-->
      <!--        <el-select-->
      <!--          v-model="queryParams.fGoodsid"-->
      <!--          filterable-->
      <!--          remote-->
      <!--          clearable-->
      <!--          style="width: 200px"-->
      <!--          :remote-method="goodsRemoteMethod"-->
      <!--          @keyup.enter.native="handleQuery"-->
      <!--          placeholder="请输入货物品名"-->
      <!--        >-->
      <!--          <el-option-->
      <!--            v-for="(dict, index) in goodsOptions"-->
      <!--            :key="index.fId"-->
      <!--            :label="dict.fName"-->
      <!--            :value="dict.fId"-->
      <!--          ></el-option>-->
      <!--        </el-select>-->
      <!--      </el-form-item>-->
      <el-form-item label="制单部门" prop="fDeptid">
        <el-input
          v-model="queryParams.fDeptid"
          placeholder="请输入制单部门"
          clearable
          size="small"
          @keyup.enter.native="handleQuery"
        />
      </el-form-item>
      <el-form-item label="有效期起" prop="fBegindate">
        <el-date-picker clearable size="small" style="width: 200px"
                        v-model="queryParams.fBegindate"
                        type="date"
                        value-format="yyyy-MM-dd"
                        placeholder="选择有效期起"
        >
        </el-date-picker>
      </el-form-item>
      <el-form-item label="有效期至" prop="fEnddate">
        <el-date-picker clearable size="small" style="width: 200px"
                        v-model="queryParams.fEnddate"
                        type="date"
                        value-format="yyyy-MM-dd"
                        placeholder="选择有效期至"
        >
        </el-date-picker>
      </el-form-item>
      <el-form-item label="协议编号" prop="fContractno">
        <el-input
          v-model="queryParams.fContractno"
          placeholder="请输入协议编号"
          clearable
          size="small"
          @keyup.enter.native="handleQuery"
        />
      </el-form-item>
      <el-form-item>
        <el-button type="cyan" icon="el-icon-search" size="mini" @click="handleQuery">搜索</el-button>
        <el-button icon="el-icon-refresh" size="mini" @click="resetQuery">重置</el-button>
      </el-form-item>
    </el-form>

    <el-row :gutter="10" class="mb8">
      <el-col :span="1.5">
        <el-button
          type="primary"
          icon="el-icon-plus"
          size="mini"
          @click="handleAdd()"
          v-hasPermi="['agreement:agreementStorage:add']"
        >新增
        </el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button
          type="warning"
          icon="el-icon-download"
          size="mini"
          @click="handleExport"
          v-hasPermi="['agreement:agreementStorage:export']"
        >导出
        </el-button>
      </el-col>
      <right-toolbar :showSearch.sync="showSearch" @queryTable="getList"></right-toolbar>
    </el-row>

    <el-table v-loading="loading" :data="agreementList" @selection-change="handleSelectionChange">
      <el-table-column type="selection" width="55" align="center"/>
      <el-table-column label="合同编号" align="center" prop="fContractno" show-overflow-tooltip/>
      <el-table-column label="客户名称" align="center" prop="fCorpid" show-overflow-tooltip/>
      <!--      <el-table-column label="货物品名" align="center" prop="fGoodsid"/>-->
      <el-table-column label="有效期起" align="center" prop="fBegindate" width="180">
        <template slot-scope="scope">
          <span>{{ parseTime(scope.row.fBegindate, '{y}-{m}-{d}') }}</span>
        </template>
      </el-table-column>
      <el-table-column label="有效期至" align="center" prop="fEnddate" width="180">
        <template slot-scope="scope">
          <span>{{ parseTime(scope.row.fEnddate, '{y}-{m}-{d}') }}</span>
        </template>
      </el-table-column>
      <!--      <el-table-column label="状态" align="center" prop="fId" />-->
      <el-table-column label="是否启用" align="center" prop="fStatus">
        <template slot-scope="scope">
          <el-switch
            v-model="scope.row.fStatus"
            active-value="0"
            inactive-value="1"
            @change="handleStatusChange(scope.row)"
          ></el-switch>
        </template>
      </el-table-column>
      <el-table-column label="状态" align="center" prop="fBillstatus">
        <template slot-scope="scope">
          <span v-if="scope.row.fBillstatus === '1'">保存</span>
          <span v-else-if="scope.row.fBillstatus === '2'">暂存</span>
          <span v-else-if="scope.row.fBillstatus === '3'">审批驳回</span>
          <span v-else-if="scope.row.fBillstatus === '4'">提交审核</span>
          <span v-else-if="scope.row.fBillstatus === '5'">审核中</span>
          <span v-else-if="scope.row.fBillstatus === '6'">审核完成</span>
        </template>
      </el-table-column>
      <el-table-column label="操作" align="center" class-name="small-padding fixed-width">
        <template slot-scope="scope">
          <el-button
            size="mini"
            type="text"
            icon="el-icon-view"
            @click="check_s(scope.row,0)"
            v-hasPermi="['agreement:agreementStorage:edit']"
          >查看
          </el-button>
          <el-button
            size="mini"
            type="text"
            icon="el-icon-view"
            @click="check(scope.row,1)"
            v-hasPermi="['agreement:agreementStorage:edit']"
            v-if="scope.row.fBillstatus === '4' || scope.row.fBillstatus === '5'"
          >审批进度
          </el-button>

          <el-button
            size="mini"
            type="text"
            icon="el-icon-edit"
            @click="handleUpdate(scope.row)"
            v-hasPermi="['agreement:agreementStorage:edit']"
            v-if="scope.row.fBillstatus < 4"
          >修改
          </el-button>
          <el-button
            size="mini"
            type="text"
            icon="el-icon-delete"
            @click="handleDelete(scope.row)"
            v-if="scope.row.fBillstatus < 4"
            v-hasPermi="['agreement:agreementStorage:remove']"
          >删除
          </el-button>
        </template>
      </el-table-column>
    </el-table>
    <pagination
      v-show="total>0"
      :total="total"
      :page.sync="queryParams.pageNum"
      :limit.sync="queryParams.pageSize"
      @pagination="getList"
    />
    <!-- 添加或修改仓储费对话框 -->
    <el-dialog :title="title" :visible.sync="open" width="65%" append-to-body :show-close="colseButton"
               :close-on-click-modal="false"
    >
      <el-form ref="form" :model="form" :rules="rules" label-width="80px"
               style="display: flex;flex-wrap: wrap;"
      >
        <el-form-item label="客户名称" prop="fCorpid">
          <el-select
            :disabled="notChange"
            v-model="form.fCorpid"
            filterable
            remote
            clearable
            style="width: 200px"
            @keyup.enter.native="handleQuery"
            :remote-method="corpsRemoteMethod"
            placeholder="请输入客户名称"
          >
            <el-option
              v-for="(dict, index) in fMblnoOptions"
              :key="index.fId"
              :label="dict.fName"
              :value="dict.fId"
            ></el-option>
          </el-select>
        </el-form-item>

        <el-form-item label="制单部门">
          <el-input v-model="deptName" :disabled="true" placeholder="请输入制单部门" style="width: 200px"/>
        </el-form-item>
        <el-form-item label="有效期起" prop="fBegindate">
          <el-date-picker clearable size="small" style="width: 200px"
                          v-model="form.fBegindate"
                          type="date"
                          :disabled="notChange"
                          value-format="yyyy-MM-dd"
                          placeholder="选择有效期起"
          >
          </el-date-picker>
        </el-form-item>
        <el-form-item label="有效期至" prop="fEnddate">
          <el-date-picker clearable size="small" style="width: 200px"
                          v-model="form.fEnddate"
                          :disabled="notChange"
                          type="date"
                          value-format="yyyy-MM-dd"
                          placeholder="选择有效期至"
          >
          </el-date-picker>
        </el-form-item>
        <el-form-item label="合同编号" prop="fContractno">
          <el-input v-model="form.fContractno" :disabled="notChange" placeholder="请输入合同编号" style="width: 200px"/>
        </el-form-item>

        <el-form-item label="商品类别" prop="tPackages">
          <el-select v-model="form.tPackages" :disabled="notChange" placeholder="请选择商品类别">
            <el-option
              v-for="dict in fTypeidOptions"
              :key="dict.dictValue"
              :label="dict.dictLabel"
              :value="dict.dictValue"
              style="width: 210px;"
            ></el-option>
          </el-select>
        </el-form-item>
      </el-form>
      <el-button type="primary" @click="submit" :disabled="notChange">请 核</el-button>

      <div class="dialogTableTitle flex a-center jlr">
        <h2>标题</h2>
        <el-button @click="getList_s()" :disabled="notChange">新增</el-button>
      </div>
      <el-table v-loading="loading_s" :data="agreementitemsList" @selection-change="handleSelectionChange">
        <!--        <el-table-column type="selection" width="55" align="center"/>-->
        <el-table-column label="行号" align="center" type="index"/>

        <el-table-column
          prop="fFeeunitid"
          header-align="center"
          align="center"
          width="180px"
          label="计价单位"
        >
          <template slot-scope="scope">
            <el-select
              v-model="scope.row.fFeeunitid"
              placeholder="请选择计价单位"
              @change="changeFeeUnit(scope.row)"
              clearable
              :disabled="browseStatus"
            >
              <el-option
                v-for="(dict, index) in jFeetunitOptions"
                :key="index.dictValue"
                :label="dict.dictLabel"
                :value="dict.dictValue"
              />
            </el-select>
          </template>
        </el-table-column>
        <el-table-column label="开始天数" align="center">
          <template slot-scope="scope">
            <el-input
              v-model="scope.row.fFromdays"
              placeholder="请输入开始天数"
              oninput='value = value.replace(/[^\d.]/g,"")'
              clearable
              size="small"
              :disabled="notChange"
            />
          </template>
        </el-table-column>
        <el-table-column label="结束天数" align="center">
          <template slot-scope="scope">
            <el-input
              v-model="scope.row.fEndays"
              placeholder="请输入结束天数"
              oninput='value = value.replace(/[^\d.]/g,"")'
              clearable
              size="small"
              :disabled="notChange"
            />
          </template>
        </el-table-column>
        <el-table-column label="单价" align="center">
          <el-input
            slot-scope="scope"
            v-model="scope.row.fPrice"
            placeholder="请输入单价"
            oninput='this.value=this.value.replace(/[^\-?\d.]/g,"").replace(/^(\-)*(\d+)\.(\d\d).*$/, "$1$2.$3")'
            clearable
            size="small"
            :disabled="notChange"
          />
        </el-table-column>
        <el-table-column label="录入人" align="center">
          <el-input
            slot-scope="scope"
            v-model="scope.row.createBy"
            :disabled="true"
            placeholder="默认录入人"
            clearable
            size="small"
          />
        </el-table-column>
        <el-table-column label="录入时间" align="center">
          <el-input
            slot-scope="scope"
            v-model="scope.row.createTime"
            placeholder="默认录入时间"
            :disabled="true"
            clearable
            size="small"
          />
        </el-table-column>

        <el-table-column
          prop="fFeeid"
          header-align="center"
          align="center"
          width="180px"
          label="费用名称"
        >
          <template slot-scope="scope">
            <el-select
              v-model="scope.row.fFeeid"
              filterable
              remote
              :disabled="browseStatus"
              :remote-method="fWRemoteMethod"
              placeholder="费用名称"
            >
              <el-option
                v-for="(dict, index) in fWbuOptions"
                :key="index.fId"
                :label="dict.fName"
                :value="dict.fId"
              ></el-option>
            </el-select>
          </template>
        </el-table-column>
        <el-table-column label="操作" align="center" class-name="small-padding fixed-width">
          <template slot-scope="scope">
            <el-button
              size="mini"
              type="text"
              icon="el-icon-delete"
              :disabled="browseStatus"
              @click.native.prevent="deleteRow(scope.$index, agreementitemsList)"
            >删除
            </el-button>
          </template>
        </el-table-column>
      </el-table>
      <div slot="footer" class="dialog-footer">
        <add-or-update v-if="addOrUpdateVisible" ref="addOrUpdate" @refreshDataList="getDataList"></add-or-update>
        <approval-comments v-if="addOrUpdateVisib" ref="ApprovalComments" @refreshDataList="returnData"></approval-comments>
        <el-button v-if="approve === true" @click="goApproval">审批</el-button>
        <el-button type="danger" @click="backApproval" v-if="form.fBillstatus === '4' && operator === lander">撤销审批</el-button>
        <el-button type="info" v-if="form.fBillstatus >= 3" @click="addOrUpdateHandle()">查看审批流</el-button>
        <el-button type="success" @click="backrRconciliation" v-if="form.fBillstatus === '6'">撤销请核</el-button>
        <el-button type="primary" @click="submitForm" :disabled="notChange">保 存</el-button>
        <el-button v-if="cancelButton === true" @click="cancel">取 消</el-button>
        <el-button v-if="cancelButton === false" @click="homePage">取消</el-button>
      </div>
    </el-dialog>
  </div>
</template>

<script>
import moment from 'moment'
import {
  RevocationApproval,
  backFee,
  PleaseCheck,
  listAgreements,
  getAgreement,
  delAgreement,
  addAgreement,
  updateAgreement_s,
  exportAgreement,
  listAgreementitems,
  queryUserVal
} from '@/api/warehouseBusiness/agreement'
import { listCorps } from '@/api/basicdata/corps'
import { listGoods } from '@/api/basicdata/goods'
import { delWarehousebills } from '@/api/warehouseBusiness/warehouseInStock'
import { listGoodsTransfer } from '@/api/warehouseBusiness/goodsTransfer'
import { listFees } from '@/api/basicdata/fees'
import { changeUserStatus } from '@/api/system/user'
import AddOrUpdate from '@/views/viewApproval'
import ApprovalComments from '@/views/startApproval'
import Global from '@/layout/components/global'
// import { listUser, queryUserVal } from '@/api/system/user'

export default {
  name: 'Agreement',
  components: {
    AddOrUpdate,
    ApprovalComments
  },
  data() {
    return {
      colseButton:true,
      cancelButton:true,
      // 审批状态
      approve:false,
      addOrUpdateVisible: false,
      addOrUpdateVisib:false,
      notChange: false,
      dataList: '',
      value_s: [],
      // 遮罩层
      loading: true,
      loading_s: false,
      browseStatus: false,
      // 计价单位
      jFeetunitOptions: [],
      agreementId: 310,
      goodsOptions: [],
      fTypeidOptions: [],
      // 选中数组
      ids: [],
      deptName: '',
      // 客户(客户数据)
      fMblnoOptions: [],
      fFeeunitidOptions: [],
      fWbuOptions: [],
      // 非单个禁用
      single: true,
      // 非多个禁用
      multiple: true,
      // 显示搜索条件
      showSearch: true,
      // 总条数
      total: 0,
      // 仓储费表格数据
      agreementList: [],
      // 弹出层标题
      title: '',
      add: '',
      // 是否显示弹出层
      open: false,
      // 结算方式,也可以从表t_stltypes中下拉选择，存储id，显示name字典
      fStltypeidOptions: [],
      // 货物类别,存储t_packages，f_id 显示名称，可以多选t_packages 中的no或 name，模糊查找选择后，存储f_id，显示name字典
      tPackagesOptions: [],
      // 贸易方式,对应t_trademodels 字典
      fTrademodeidOptions: [],
      // 仓储费明细表表格数据
      agreementitemsList: [],
      // 操作人
      operator: '',
      lander: '',
      // 查询参数
      queryParams: {
        pageNum: 1,
        pageSize: 10,
        fBillno: null,
        fDeptid: null,
        fContractno: null,
        fCorpid: null,
        fStltypeid: null,
        fGoodsid: null,
        fFeetypeid: null,
        tPackages: null,
        fTrademodeid: null,
        fFreedays: null,
        fBegindate: null,
        fEnddate: null,
        fBillstatus: null,
        fStatus: null
      },
      // 表单参数
      form: {},
      // 表单校验
      rules: {
        fBillno: [
          {
            required: true,
            message: ' ',
            trigger: 'blur'
          }
        ],
        fCorpid: [
          { required: true, message: ' ', trigger: 'blur' }
        ],
        tPackages:[
          { required: true, message: ' ', trigger: 'blur' }
        ],
        fBegindate:[
          { required: true, message: ' ', trigger: 'blur' }
        ],
        fEnddate:[
          { required: true, message: ' ', trigger: 'blur' }
        ]
      }
    }
  },
  created() {
    this.getList()
    this.getDicts('data_settlement_method').then(response => {
      this.fStltypeidOptions = response.data
    })
    this.getDicts('data_package_unit').then(response => {
      this.tPackagesOptions = response.data
    })
    this.getDicts('data_trademodes').then(response => {
      this.fTrademodeidOptions = response.data
    })
    this.getDicts('data_goods_category').then(response => {
      this.fTypeidOptions = response.data
    })
    this.getDicts("data_unitfees").then(response => {
      this.jFeetunitOptions = response.data;
    });
    this.register()
  },
  activated(){
    this.Jump()
  },
  methods: {
    homepaGe(){
      let view = {
        fullPath: "/agreement/agreementStorage",
        hash: "",
        matched: Array(2),
        meta: Object,
        name: "AgreementStorage",
        params: Object,
        path: "/agreement/agreementStorage",
        query: Object,
        title: "仓储费协议"
      }
      this.$router.push({ path: '/index'})
      this.$store.dispatch('tagsView/delView', view).then(({ visitedViews }) => {
        if (this.isActive(view)) {
          this.toLastView(visitedViews, view)
        }
      })
      Global.$emit("removeCache", "closeSelectedTag", view);
    },
    homePage() {
      this.open = false
      let view = {
        fullPath: "/agreement/agreementStorage",
        hash: "",
        matched: Array(2),
        meta: Object,
        name: "AgreementStorage",
        params: Object,
        path: "/agreement/agreementStorage",
        query: Object,
        title: "仓储费协议"
      }
      this.$router.push({ path: '/index' })
      this.$store.dispatch('tagsView/delView', view).then(({ visitedViews }) => {
        if (this.isActive(view)) {
          this.toLastView(visitedViews, view)
        }
      })
      Global.$emit("removeCache", "closeSelectedTag", view);
    },
    Jump(){
      this.approval = this.$route.query.data
      if(this.approval) {

        this.approval = JSON.parse(this.approval)
        this.colseButton = false
        this.hide = false
        this.open = true
        this.notChange = true
        this.approve = true
        this.cancelButton = false
        this.reset()
        getAgreement(this.approval.billId).then(response => {
          this.deptName = response.data.dept.deptName
          this.form = response.data.tWarehouseAgreement
          this.fMblnoOptions = response.data.corps
          this.agreementitemsList = response.data.tWarehouseAgreementitems
          for (let item in this.agreementitemsList) {
            this.$set(this.agreementitemsList[item], 'fFeeunitid', this.agreementitemsList[item].fFeeunitid + '')
            // this.fWRemoteMethod(this.agreementitemsList[item].fFeeid)
          }
          this.fWbuOptions = response.data.feesList
          // this.add = row
          this.open = true
          this.browseStatus = true
        })
      }
    },
    goApproval(){
      this.addOrUpdateVisib = true
      this.$nextTick(() => {
        this.$refs.ApprovalComments.init(this.form.fId,this.agreementId)
      })
    },
    returnData(){
      this.addOrUpdateVisib = false
      this.open = false
      this.homepaGe()

    },
    getDataList(){
      this.addOrUpdateVisible = false
    },
    // 查看审批流
    addOrUpdateHandle() {
      this.addOrUpdateVisible = true
      this.addOrUpdateVisib = false
      let id = '448'
      let actId = '110'
      this.$nextTick(() => {
        this.$refs.addOrUpdate.init(this.form.fId, this.agreementId)
      })
    },
    register() {
      queryUserVal().then((response) => {
        this.lander = response.user.userName
      })
    },
    check_s(row, res) {
      this.notChange = true
      this.browseStatus = true
      this.register()
      getAgreement(row.fId).then(response => {
        this.deptName = response.data.dept.deptName
        this.form = response.data.tWarehouseAgreement
        this.operator = this.form.createBy
        this.fMblnoOptions = response.data.corps
        this.agreementitemsList = response.data.tWarehouseAgreementitems
        for (let item in this.agreementitemsList) {
          this.$set(this.agreementitemsList[item], 'fFeeunitid', this.agreementitemsList[item].fFeeunitid + '')
        }
        this.fWbuOptions = response.data.feesList
        this.add = row
        this.title = '修改仓储费'
      })
      getAgreement(row.fId).then(response => {
        this.deptName = response.data.dept.deptName
        this.form = response.data.tWarehouseAgreement
        this.fMblnoOptions = response.data.corps
        this.agreementitemsList = response.data.tWarehouseAgreementitems
        for (let item in this.agreementitemsList) {
          this.$set(this.agreementitemsList[item], 'fFeeunitid', this.agreementitemsList[item].fFeeunitid + '')
        }
        this.fWbuOptions = response.data.feesList
        this.add = row
        this.open = true
      })
    },
    // 查看按钮
    check(row, res) {
      this.notChange = true
      this.browseStatus = true
      this.register()
      getAgreement(row.fId).then(response => {
        this.deptName = response.data.dept.deptName
        this.form = response.data.tWarehouseAgreement
        this.operator = this.form.createBy
        this.fMblnoOptions = response.data.corps
        this.agreementitemsList = response.data.tWarehouseAgreementitems
        for (let item in this.agreementitemsList) {
          this.$set(this.agreementitemsList[item], 'fFeeunitid', this.agreementitemsList[item].fFeeunitid + '')
        }
        this.fWbuOptions = response.data.feesList
        this.add = row
        this.title = '修改仓储费'
      })
      this.open = true
    },
    //撤销审批
    backApproval() {
      let data = {
        id: this.form.fId,
        actId: this.agreementId,
        billId: this.form.fId
      }
      RevocationApproval(data).then(data => {
        if (data.code === 200) {
          this.$message.success('撤销成功')
          this.open = false
          this.getList()
        }
      })
    },
    // 撤销请核
    backrRconciliation() {
      let formData = new window.FormData()
      // 附件数据
      formData.append('agreement', JSON.stringify(this.form))
      formData.append('agreementitems', JSON.stringify(this.agreementitemsList))
      backFee(formData).then(response => {
        this.msgSuccess('撤销成功')
        this.open = false
        this.getList()
      })
    },
    // 请核按钮
    submit() {
      if (this.agreementitemsList.length <= 0) {
        this.$message.error('仓储费协议明细为空，无法操作')
        return false
      }
      for (let agr = 0; agr < this.agreementitemsList.length; agr ++) {
        if (!this.agreementitemsList[agr].fFeeunitid) {
          this.$message.error('请维护仓储费明细计价单位')
          return false
        }
        if (!this.agreementitemsList[agr].fFromdays) {
          this.$message.error('请维护仓储费明细开始天数')
          return false
        }
        if (!this.agreementitemsList[agr].fEndays) {
          this.$message.error('请维护仓储费明细结束天数')
          return false
        }
        if (!this.agreementitemsList[agr].fPrice) {
          this.$message.error('请维护仓储费明细单价')
          return false
        }
        if (!this.agreementitemsList[agr].fFeeid) {
          this.$message.error('请维护仓储费明细费用名称')
          return false
        }
      }
      this.$refs['form'].validate(valid => {
        if (valid) {
          let formData = new window.FormData()
          formData.append('agreement', JSON.stringify(this.form))
          formData.append('agreementitems', JSON.stringify(this.agreementitemsList))
          PleaseCheck(formData).then(response => {
            this.msgSuccess('请核成功')
            this.open = false
            this.getList()
          })
        }
      })
    },
    // 仓储费状态修改
    handleStatusChange(row) {
      if(row.fBillstatus == '6'){
        let text = row.fStatus === '0' ? '启用' : '停用'
        this.$confirm('确认要"' + text + '""' + row.fCorpid + '"用户吗?', '警告', {
          confirmButtonText: '确定',
          cancelButtonText: '取消',
          type: 'warning'
        }).then(function() {
          return updateAgreement_s(row.fId, row.fStatus)
        }).then(() => {
          this.msgSuccess(text + '成功')
        }).catch(function() {
          row.fStatus = row.fStatus === '0' ? '1' : '0'
        })
      }else{
        row.fStatus = 0
        this.$message.error('审核完成时才能启用');
      }
    },
    /** 创建仓储费明细表列表 */
    getList_s() {
      queryUserVal().then((response) => {
        this.agreementitemsList.push({
          //行号
          fLineno: '',
          //计价单位
          fFeeunitid: '',
          //费用名称
          fFeeid: '',
          //开始天数
          fFromdays: '',
          //结束天数
          fEndays: '',
          //单价
          fPrice: '',
          //录入人
          createBy: response.user.userName,
          //创建时间
          createTime: moment(Date.parse(new Date())).format('YYYY-MM-DD HH:mm:ss')
        })
        // this.$set("deptName", response.dept.deptName);
        this.deptName = response.dept.deptName
        this.form.fDeptid = response.dept.deptId
        this.agreementitemsList.createBy = response.user.userName

        // this.$set(this.agreementitemsList, "createBy", response.user.userName);
        //格式化时间戳
        // this.$set(this.agreementitemsList, "createTime", moment(Date.parse(new Date())).format("YYYY-MM-DD HH:mm:ss"));
      })

      listAgreementitems(this.queryParams).then(response => {
      })
    },
    /* 远程模糊查询商品 */
    goodsRemoteMethod(name) {
      if (name == null || name === '') {
        return false
      }
      let queryParams = { pageNum: 1, pageSize: 10, fName: name }
      listGoods(queryParams).then((response) => {
        this.goodsOptions = response.rows
      })
    },
    // 计价单位
    fFeeunitidFormat(row, column) {
      return this.selectDictLabel(this.fFeeunitidOptions, row.fFeeunitid)
    },
    /** 查询仓储费列表 */
    getList() {
      this.loading = true
      listAgreements(this.queryParams).then(response => {
        this.agreementList = response.rows
        this.total = response.total
        this.loading = false
      })
    },
// 远程模糊查询费用名称
    fWRemoteMethod(name) {
      this.fWbuOptions = []
      if (name == null || name === '') {
        return false
      }
      let queryParams = { pageNum: 1, pageSize: 10, fName: name }
      listFees(queryParams).then((response) => {
        this.fWbuOptions = response.rows
      })
    },
    // 结算方式,也可以从表t_stltypes中下拉选择，存储id，显示name字典翻译
    fStltypeidFormat(row, column) {
      return this.selectDictLabel(this.fStltypeidOptions, row.fStltypeid)
    },
    // 货物类别,存储t_packages，f_id 显示名称，可以多选t_packages 中的no或 name，模糊查找选择后，存储f_id，显示name字典翻译
    tPackagesFormat(row, column) {
      return this.selectDictLabel(this.tPackagesOptions, row.tPackages)
    },
    // 贸易方式,对应t_trademodels 字典翻译
    fTrademodeidFormat(row, column) {
      return this.selectDictLabel(this.fTrademodeidOptions, row.fTrademodeid)
    },
    // 取消按钮
    cancel() {
      this.open = false
      this.reset()
      this.getList()
      this.agreementitemsList = []
    },
    handleClose() {
      this.open = false
      this.reset()
      this.getList()
      this.agreementitemsList = []
    },
    // 表单重置
    reset() {
      this.form = {
        fId: null,
        fBillno: null,
        fDeptid: null,
        fContractno: null,
        fCorpid: null,
        fStltypeid: null,
        fGoodsid: null,
        fFeetypeid: null,
        tPackages: null,
        fTrademodeid: null,
        fFreedays: null,
        fBegindate: null,
        fEnddate: null,
        fBillstatus: null,
        delFlag: null,
        createBy: null,
        createTime: null,
        updateBy: null,
        updateTime: null,
        remark: null
      }
      this.resetForm('form')
    },
    /** 搜索按钮操作 */
    handleQuery() {
      this.queryParams.pageNum = 1
      this.getList()
    },
    // 变更计价单位
    changeFeeUnit(row) {
      if (!row.fFeeUnitid) {
        return false
      }
      if (row.fFeeUnitid === '0') {
        this.$set(row, 'fQty', this.fCntqty)
      } else if (row.fFeeUnitid === '1') {
        this.$set(row, 'fQty', this.fGrossweight)
      }
      if (row.fUnitprice) {
        this.$set(
          row,
          'fAmount',
          parseFloat(Number(row.fUnitprice) * Number(row.fQty)).toFixed(2)
        )
      }
    },
    /** 重置按钮操作 */
    resetQuery() {
      this.resetForm('queryForm')
      this.handleQuery()
    },
    // 多选框选中数据
    handleSelectionChange(selection) {
      this.ids = selection.map(item => item.fId)
      this.single = selection.length !== 1
      this.multiple = !selection.length
    },
    /** 新增按钮操作 */
    handleAdd() {
      this.reset()
      // this.agreementitemsList = {
      //   fFeeunitid:'',
      //   fFromdays:'',
      //   fEndays:'',
      //   fPrice:'',
      //   fFeeid:''
      // }
      this.open = true
      this.browseStatus = false
      this.notChange = false
      this.title = '添加仓储费'
      queryUserVal().then((response) => {
        // this.$set("deptName", response.dept.deptName);
        this.deptName = response.dept.deptName
        this.form.fDeptid = response.dept.deptId
        // this.agreementitemsList.createBy = response.user.userName

        // this.$set(this.agreementitemsList, "createBy", response.user.userName);
        //格式化时间戳
        // this.$set(this.agreementitemsList, "createTime", moment(Date.parse(new Date())).format("YYYY-MM-DD HH:mm:ss"));
      })
    },
    /** 修改按钮操作 */
    handleUpdate(row) {
      // this.reset()
      this.notChange = false
      this.browseStatus = false
      const fId = row.fId || this.ids
      getAgreement(fId).then(response => {
        this.deptName = response.data.dept.deptName
        this.form = response.data.tWarehouseAgreement
        this.fMblnoOptions = response.data.corps
        this.agreementitemsList = response.data.tWarehouseAgreementitems
        for (let item in this.agreementitemsList) {
          this.$set(this.agreementitemsList[item], 'fFeeunitid', this.agreementitemsList[item].fFeeunitid + '')
          // this.fWRemoteMethod(this.agreementitemsList[item].fFeeid)
        }
        this.fWbuOptions = response.data.feesList
        this.add = row
        this.open = true
        this.title = '修改仓储费'
      })
    },
    /** 远程模糊查询用户 */
    corpsRemoteMethod(name) {
      if (name == null || name === '') {
        return false
      }
      let queryParams = { pageNum: 1, pageSize: 10, fName: name, type: 1 }
      listCorps(queryParams).then((response) => {
        this.fMblnoOptions = response.rows
        this.KHblnoOptions = response.rows
      })
    },
    debounce(fn, delay) {
      let timerId = null;
      return function () {
        let self = this;
        let args = arguments;
        timerId && clearTimeout(timerId);
        timerId = setTimeout(function () {
          fn.apply(self, args);
        }, delay || 1000);
      }
    },
    /** 保存按钮 */
    submitForm() {
      this.$refs['form'].validate(valid => {
        if (valid) {
          let formData = new window.FormData()
          formData.append('agreement', JSON.stringify(this.form))
          formData.append('agreementitems', JSON.stringify(this.agreementitemsList))
          addAgreement(formData).then(response => {
            this.msgSuccess('操作成功')
            this.$set(this.form, 'fId', response.data.tWarehouseAgreement.fId)
            this.$set(this.form, 'fBillsStatus', response.data.tWarehouseAgreement.fBillsStatus)
          })
        }
      })
    },
    /** 删除按钮操作 */
    handleDelete(row) {
      const fIds = row.fId || this.ids
      this.$confirm('是否确认删除仓储费编号为"' + fIds + '"的数据项?', '警告', {
        confirmButtonText: '确定',
        cancelButtonText: '取消',
        type: 'warning'
      }).then(function() {
        return delAgreement(fIds)
      }).then(() => {
        this.getList()
        this.msgSuccess('删除成功')
      })
    },
    /** 导出按钮操作 */
    handleExport() {
      const queryParams = this.queryParams
      this.$confirm('是否确认导出所有仓储费数据项?', '警告', {
        confirmButtonText: '确定',
        cancelButtonText: '取消',
        type: 'warning'
      }).then(function() {
        return exportAgreement(queryParams)
      }).then(response => {
        this.download(response.msg)
      })
    },
    deleteRow(index, rows) {
      rows.splice(index, 1)
    }
  }
}
</script>
